General Instruction Guidebook for Using R 

The General Instructions Guidebook (GIG) for using R provides all the code to run the analyses. The examples given in this guide are taken from Statistics for the Behavioral Sciences, 3rd Edition. You can use the code to complete each exercise in R and refer to the examples in the textbook to clear up any points of confusion. 

#########################################
#########################################
#########################################
#########################################
#########################################
#To The Student - How to Use R With This Book

help(mean)

c(1,2,3)
v.example <- c(1,2,3)
v.example

scores <- c(88,92,71)
scores

df <- data.frame(v.example,scores)
df

names(df) <- c("Student ID", "Scores")
df

df$Gender <-c("M","F","F")
df

df$Scores

str(df)
class(scores)
scores.2<-as.character(scores)
scores.2
scores.2+3
scores.2<-as.numeric(scores.2)
scores.2
scores.2+3

help(mean)
height <- c(165,179,NA,142)
height
mean(height)
mean(height,na.rm=TRUE)
(165+179+142)/3

new <- data.frame(ID=c(1,2,3,4), Score=c(94,83,72,89), 
                  Gender=c("M","F","F","F"))
new

getwd()
setwd("C:/Users/Dropbox/RPractice") # modify this to where you want
#to save your R objects 
write.csv(new, "C:/Users/Dropbox/RPractice/df.csv") #again, modify
#this to where you want to save the "new" dataframe 

read.csv(file.choose())

install.packages("foreign")
library(foreign)
SPSS.File <- read.spss("C:\PathToFile\MyDataFile.sav", to.data.frame=TRUE)
#again, you may have to change the directory, depending on where you
#have the .sav file saved 

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 1
GPA.Scores <- data.frame("Class 1" = c(3.3,2.9,3.5,3.6,3.1),
                         "Class 2" = c(3.9,4.0,2.4,3.1,3.0),
                         "Class 3" = c(2.7,2.3,2.2,3.0,2.8))
GPA.Scores


GPA_Scores <- data.frame(Class1 = c(3.3,2.9,3.5,3.6,3.1),
                         Class2 = c(3.9,4.0,2.4,3.1,3.0),
                         Class3 = c(2.7,2.3,2.2,3.0,2.8))
GPA_Scores

GPA.Scores.Row <- data.frame(Class = c(rep(1,5),rep(2,5),rep(3,5)),
                             GPA = c(3.3,2.9,3.5,3.6,3.1,3.9,4.0,
                                     2.4,3.1,3.0,2.7,2.3,2.2,3.0,
                                     2.8))
GPA.Scores.Row

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 2

#2.4
complaints <- data.frame(Complaints=c(45,98,83,50,86,66,66,88,
                                      95,73,88,55,76,115,66,92,
                                      110,79,105,101,101,85,90,
                                      92,81,55,95,91,92,78,66,
                                      73,58,86,92,51,63,91,77,
                                      88,86,94,80,102,107))
complaints

order(complaints$Complaints)
sort(complaints$Complaints)
table(complaints$Complaints)

prop.table(table(complaints$Complaints))
round(prop.table(table(complaints$Complaints)),4)
round(prop.table(table(complaints$Complaints)),4)*100
safety.data <- round(prop.table(table(complaints$Complaints)),4)*100
cumsum(safety.data)

#2.7
BMI <- data.frame(BMI=c("lean","healthy","overweight",
                        "obese"), Total=c(15,30,35,20))
BMI

prop.table(BMI$Total)
prop.table(BMI$Total)*100
cumsum(prop.table(BMI$Total)*100)

BMI.2 <-data.frame(BMI=c("lean","lean","healthy","overweight",
                         "lean","obese","obese","obese","lean",
                         "healthy","lean","obese","lean",
                         "overweight","lean"))
BMI.2
table(BMI.2)
prop.table(table(BMI.2))
cumsum(c(.47,.13,.13,.27))

#2.12
numbers <- data.frame(numbers=c(1,4,5,7,2,3,6,8,3,6,7,9,2,6,5,
                                4,4,5,8,5))
numbers
hist(numbers$numbers)
hist(numbers$numbers, n=15, main="Histogram",xlab="Numbers")
par(mfrow=c(2,1))
hist(numbers$numbers, n=2, main="Histogram",xlab="Numbers")
hist(numbers$numbers, n=15, main="Histogram",xlab="Numbers")
par(mfrow=c(1,1))

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 3

#3.6
clips <- data.frame(Time=c(41,65,123,46,48,87,38,90,132,115,
                           80,80,64,59,51,36,80,143,122,100))
clips

install.packages("psych")
library(psych)
describe(clips$Time)
mean(clips$Time)
median(clips$Time)
mode(clips$Time) # Does not give you the mode you want!

sort(clips$Time)
table(clips$Time)
sort(table(clips$Time))

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 4

#4.11
clips <- data.frame(Time=c(41,65,123,46,48,87,38,90,132,115,
                           80,80,64,59,51,36,80,143,122,100))
clips

sd(clips$Time)
var(clips$Time)
range(clips$Time)
max(clips$Time) - min(clips$Time)

library(psych)
describe(clips$Time)
install.packages("pastecs")
library(pastecs)
stat.desc(clips$Time) 

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 5

#5.6
hosp.ins <-data.frame(hospital=c(rep("A.public",130),rep("B.private",70)),
                      insurance=c(rep("insured",50),rep("uninsured",80),
                                  rep("insured",40),rep("uninsured",30)))
hosp.ins
head(hosp.ins)
table(hosp.ins)
addmargins(table(hosp.ins))

round(prop.table(table(hosp.ins),1),3) # by row; conditional upon hospital
round(prop.table(table(hosp.ins),2),3) # by column; conditional upon insurance

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 6

#6.8
SAT <- data.frame(SAT=c(500,750,600,900,950,880,990,560,780,800,
                        800,450,800,680,550,600))
SAT
scale(SAT$SAT,center=T, scale=T)
help(scale)

mean(SAT$SAT)
SAT$SAT-mean(SAT$SAT) # numerator for z score
scale(SAT$SAT, center=T, scale=F) #equivalent to the numerator for z score
(SAT$SAT-mean(SAT$SAT))/sd(SAT$SAT) 


#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 7

#7.7
e.call <- data.frame(reaction=c(93,66,30,44,20,100,35,58,70,81))
e.call
library(psych)
describe(e.call) # last output, "se"
27.18/sqrt(10) # sample sd divided by the square root of sample size

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 9

#9.6
OCD <- data.frame(SF.Score=c(20,60,48,92,50,82,48,90,30,68,
                             43,54,60,62,94,67,63,85))
OCD

t.test(OCD$SF.Score,mu=77.43, conf.level=.95)

#Get information to calculate effect sizes:
62-77.43
describe(OCD$SF.Score)

#Cohen's d:
round((62-77.43)/20.94,3)

#eta squared
output<-t.test(OCD$SF.Score,mu=77.43, conf.level=.95)
str(output)
output$statistic # gives us t value, -3.1259
output$statistic^2/(output$statistic^2+output$parameter)

#9.9
calories<-data.frame(Speed=c(rep("Slow",6),rep("Fast",6)),
                     Calories=c(700,450,850,600,450,550,
                                450,800,750,700,550,650))
calories
t.test(calories$Calories~calories$Speed, var.equal=T)

calories.2<-data.frame(Slow=c(700,450,850,600,450,550),
                       Fast=c(450,800,750,700,550,650))

calories.2
t.test(calories.2$Slow,calories.2$Fast,var.equal=T)

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 10

#10.4
supervision<-data.frame(present=c(220,245,215,260,300,280,250,310),
                        absent=c(210,220,195,265,275,290,220,285))

supervision

t.test(supervision$present,supervision$absent,var.equal=F,paired=T)

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 11

#11.5
#Note: This is the same data from 9.6
OCD <- data.frame(SF.Score=c(20,60,48,92,50,82,48,90,30,68,
                             43,54,60,62,94,67,63,85))
OCD

conf.95<-t.test(OCD$SF.Score,mu=77.43, conf.level=.95)
conf.90<-t.test(OCD$SF.Score,mu=77.43, conf.level=.90)
conf.95$conf.int
conf.90$conf.int

72.41446-51.58554 # 95% confidence interval = 20.82892
70.58704-53.41296 # 90% confidence interval = 17.17408

#11.7
#Note: This is the same data from 9.9
calories<-data.frame(Speed=c(rep("Slow",6),rep("Fast",6)),
                     Calories=c(700,450,850,600,450,550,
                                450,800,750,700,550,650))
calories
t.test(calories$Calories~calories$Speed, var.equal=T)

calories.2<-data.frame(Slow=c(700,450,850,600,450,550),
                       Fast=c(450,800,750,700,550,650))

calories.2
t.test(calories.2$Slow,calories.2$Fast,var.equal=T)

#11.9
#Note: This is the same data from chapter 10
supervision<-data.frame(present=c(220,245,215,260,300,280,250,310),
                        absent=c(210,220,195,265,275,290,220,285))

supervision

t.test(supervision$present,supervision$absent,var.equal=F,paired=T)

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 12

#12.8
stress<-data.frame(stress=c(rep("Low",10),rep("Moderate",10),
                            rep("High",10)), score=c(3.4,3.2,3.0,3.0,3.5,
                                                     3.8,3.6,4.0,3.9,2.9,
                                                     3.5,3.6,2.7,3.5,3.8,
                                                     2.9,3.4,3.2,3.3,3.1,
                                                     2.9,3.0,2.6,3.3,3.7,
                                                     2.7,2.4,2.5,3.3,3.4))
head(stress)

stress.a <-aov(score~stress, data=stress)
summary(stress.a)
stress.a
TukeyHSD(stress.a)

library(psych)
by(stress$score, stress$stress, describe)
.43^2 #.1849
.4^2  #.16
.33^2 #.1089
round(by(stress$score, stress$stress, var),4)

install.packages("lawstat")
library(lawstat)
levene.test(stress$score, stress$stress)
levene.test(stress$score, stress$stress, location="mean")

by(stress$score, stress$stress, describe) # Notice we do not get the same
#results we got earlier! We need to detach packages:
search()
detach(package:lawstat)
search()
detach(package:VGAM)
detach(package:splines)
detach(package:stats4)
detach(package:mvtnorm)
detach(package:Kendall)
detach(package:Hmisc)
detach(package:Formula)
detach(package:Survival)
detach(package:survival)
detach(package:lattice)
detach(package:ggplot2)

by(stress$score, stress$stress, describe)

oneway.test(score~stress, data=stress)

par(mfrow=c(2,2))
plot(stress.a)

#Approach 2
stress.lm<-lm(stress$score~stress$stress)
summary(stress.lm)
stress.anova<-anova(stress.lm)
stress.anova
confint(stress.lm)

par(mfrow=c(1,1))
boxplot(stress$score~stress$stress)

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 13

#13.6
ads <- data.frame(Person=c(rep(c("A","B","C","D","E","F","G"),3)),
                  Cues=c(rep("NoCues",7),rep("Generic",7),rep("Smoking",7)),
                  Values=c(2,3,1,4,4,5,2,5,5,4,5,3,4,2,5,6,5,7,6,7,6))
ads

tapply(ads$Values,ads$Cues,mean)
tapply(ads$Values,ads$Cues,sd)

aov.ads<-aov(Values~Cues+Error(Person),data=ads)
summary(aov.ads)

pairwise.t.test(ads$Values, ads$Cues, p.adjust="bonf", paired=T)

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 14

#14.8
sugars <- data.frame(buffet=c(rep("Absent",18),rep("Present",18)),
                     exposure=c(rep("Low",6),rep("Mod",6),rep("High",6),
                                rep("Low",6),rep("Mod",6),rep("High",6)),
                     times=c(8,7,9,10,12,8,10,12,15,8,6,9,
                             13,9,11,8,13,12,5,8,5,6,5,7,
                             15,10,8,9,7,11,15,12,15,16,12,14))
sugars

sugars.aov <- aov(times~buffet+exposure+buffet:exposure, data=sugars)
summary(sugars.aov) 

#These are other ways you can run a between-subjects ANOVA
sugars.aov2 <- aov(times ~ buffet*exposure, data=sugars) 
summary(sugars.aov2)

model <- lm(times ~ buffet + exposure + buffet:exposure, data=sugars)
anova(model)

model2 <- lm(times ~ buffet + exposure + buffet*exposure, data=sugars)
anova(model2)

TukeyHSD(sugars.aov)

interaction.plot(sugars$exposure, sugars$buffet, sugars$times)

reorder <- factor(sugars$exposure, levels=levels(sugars$exposure)[c(2,3,1)])

interaction.plot(reorder, sugars$buffet,  sugars$times,
                 ylim=range(0,16),xlab="Exposure to Sugars",
                 ylab="Time to Complete Task (in seconds)",
                 col=c("red","blue"), main="Interaction Plot")

tapply(sugars$times,sugars$buffet,mean) #to compare means
tapply(sugars$time,sugars$exposure,mean) #to compare means 

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 15

#15.4
mood <- data.frame(Mood=c(6,4,7,4,2,5,3,1),
                   Eating=c(480,490,500,590,600,400,545,650))

mood
cor.test(mood$Mood,mood$Eating,method=c("pearson"), 
         alternative=c("two.sided"),conf.level=.95)

#15.8
ranks <- data.frame(Food=c(1,1,3,4,5,6,7,8),
                    Water=c(1,3,2,6,4,7,8,5))
ranks

cor.test(ranks$Food,ranks$Water,method=c("spearman"), 
         alternative=c("two.sided"),conf.level=.95) # ERROR!

#Fix error by setting exact to FALSE:
cor.test(ranks$Food,ranks$Water,method=c("spearman"), 
         alternative=c("two.sided"),conf.level=.95,exact=F)

cor.test(ranks$Food,ranks$Water,method=c("kendall"), 
         alternative=c("two.sided"),conf.level=.95)

#15.10
comedy <- data.frame(sex=c(1,1,1,1,1,2,2,2,2,2,2,2),
                     laughter=c(23,9,12,12,29,32,10,8,20,12,24,34))
comedy

cor.test(comedy$laughter, comedy$sex)

#15.12
emp <- data.frame(Emp=c(rep(0,20),rep(1,20)),
                  Happy=c(rep(0,14),rep(1,6),rep(0,6),rep(1,14)))
emp
table(emp)
cor.test(emp$Emp,emp$Happy)

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 16

#16.7
symp <-data.frame(Sessions=c(9,5,8,2,6,3,5,4),
                  Symptoms=c(0,3,2,5,3,4,2,3))
symp

symp.model <- lm(Symptoms~Sessions, data=symp)
symp.model
summary(symp.model)

cor(symp$Sessions,symp$Symptoms)
cor.test(symp$Sessions,symp$Symptoms)
(-0.9093229)^2 #0.8268681

#16.13
sales <-data.frame(age=c(19,21,26,28,32,30),
                  education=c(12,14,13,18,17,16),
                  sales=c(20,40,30,68,70,60))
sales

sales.model <- lm(sales~age+education,data=sales)
summary(sales.model)

install.packages("QuantPsyc")
library(QuantPsyc)
lm.beta(sales.model)

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 17

#17.3
recall<-c(58,12,10)
recall
chisq.test(recall, p=c(.8,.1,.1))

#17.9
obs.matrix <- matrix(c(22,12,31,45),ncol=2,byrow=TRUE)
obs.matrix

obs.matrix2 <- matrix(c(22,12,31,45),ncol=2,byrow=FALSE)
obs.matrix2

colnames(obs.matrix) <- c("Completion","Premature Termination")
rownames(obs.matrix) <- c("Family","Individual")

obs.table<- as.table(obs.matrix)
obs.table
chisq.test(obs.table)
chisq.test(obs.table,correct=F)

#########################################
#########################################
#########################################
#########################################
#########################################
#Chapter 18

#18.3
install.packages("BSDA")
library(BSDA)

outburst <- data.frame(sub=c(3,2,5,3,4,2,0,3,1,6,4),
                       full=c(2,0,4,3,2,0,2,1,0,4,3))
outburst

SIGN.test(outburst$sub,outburst$full)

#18.5 Wilcoxon signed rank test (related conditions)
smoked <- data.frame(before=c(23,12,11,15,25,20,11,9,13,15,30,21),
                     following=c(20,16,10,0,5,8,0,15,8,13,12,0))
smoked

wilcox.test(smoked$before,smoked$following, paired=TRUE)
wilcox.test(smoked$before,smoked$following, paired=TRUE, correct=F,exact=F)
wilcox.test(smoked$before,smoked$following, paired=TRUE, correct=F, exact=T)

#18.7 Mann-Whitney U test (independent conditions)
job.sat<-data.frame(day=c(88,72,93,67,62),
                    night=c(24,55,70,60,50))
job.sat
wilcox.test(job.sat$day, job.sat$night, paired=FALSE) 

#18.9 Kruskal-Wallis H test
driving<-data.frame(ClipA=c(88,67,22,14,42),
                    ClipB=c(92,76,80,77,90),
                    ClipC=c(50,55,43,65,39))
driving
kruskal.test(driving)

driving2<-data.frame(Scores=c(88,67,22,14,42,92,76,80,77,90,
                              50,55,43,65,39),
                     Condition=c(rep("A",5),rep("B",5),rep("C",5)))
driving2
kruskal.test(driving2$Scores~driving2$Condition)

install.packages("pgirmess")
library(pgirmess)

kruskalmc(driving2$Scores~driving2$Condition)

kruskalmc(driving2$Scores~driving2$Condition, cont="two-tailed")

#18.11
trimester<-data.frame(trimester=c(rep("first",7),rep("second",7),
                                  rep("third",7)),
                                  scores=c(3,6,2,4,4,4,8,5,4,0,3,6,3,6,
                      8,7,5,2,9,7,5))
head(trimester)
friedman.test(trimester$scores~trimester$trimester)

trimester<-data.frame(first=c(3,6,2,4,4,4,8),
                      second=c(5,4,0,3,6,3,6),
                      third=c(8,7,5,2,9,7,5))
trimester

trimester.matrix<-as.matrix(trimester)
friedman.test(trimester.matrix)
